﻿using System;
using System.Runtime.InteropServices;

class Program
{

    [DllImport("Win32Project1.dll", EntryPoint = "?FAST_Func@@YIHH@Z")]
    internal static extern int FAST_Func(int value);

    [DllImport("Win32Project1.dll")]
    internal static extern int FAST_Func_By_DEF(int value);

    // Can't specify CallingConvention.FastCall
    [DllImport("Win32Project1.dll", CallingConvention = CallingConvention.FastCall)]
    internal static extern int ExternC_FAST_Func(int value);

    [DllImport("Win32Project1.dll", EntryPoint = "@ExternC_FAST_Func2@4")]
    // [DllImport("Win32Project1.dll")]
    internal static extern int ExternC_FAST_Func2(int value);

    [DllImport("Win32Project1.dll")]
    internal static extern int ExternC_FAST_Func_By_DEF(int value);

    static unsafe void Main(string[] args)
    {
        FAST_Func(5);
        FAST_Func_By_DEF(6);

        /*
    An unhandled exception of type 'System.TypeLoadException' occurred in ConsoleApplication1.exe
    Additional information: Invalid unmanaged calling convention: must be one of stdcall, cdecl, or thiscall.
        */
        // ExternC_FAST_Func(7);

        ExternC_FAST_Func2(8);

        ExternC_FAST_Func_By_DEF(9);
    }
}
